<?php

namespace App\Service;

use App\Dto\DtoInterface;
use App\Error\NotFoundError;
use App\Repository\NewsRepositoryInterface;
use App\Request\AbstractRequest;

class NewsDetailService implements ServiceInterface
{
    public function __construct(
        private readonly NewsRepositoryInterface $news,
    ) {}

    public function serve(AbstractRequest $request): DtoInterface
    {
        $news = $this->news->find($request->detailId);

        if ($news === null) {
            throw new NotFoundError('News');
        }

        return $news->getExtendedDto();
    }
}
